#ifndef _WACOM_H
#define _WACOM_H

#include <add-ons/input_server/InputServerDevice.h>
#include <List.h>
#include <OS.h>
#include <SupportDefs.h>


// export this for the input_server
extern "C" _EXPORT BInputServerDevice* instantiate_input_device();
 

class WacomInputDevice : public BInputServerDevice {
public:
							WacomInputDevice();
	virtual					~WacomInputDevice();

	virtual status_t		InitCheck();
	virtual status_t		SystemShuttingDown();

	virtual status_t		Start(const char *device, void *cookie);
	virtual	status_t		Stop(const char *device, void *cookie);
	virtual status_t		Control(const char	*device,
									void		*cookie,
									uint32		code, 
									BMessage	*message);

private:
	static int32			wack_em(void *arg);
	
	static bool				sActive;
	static int32			sSpeed;
	static thread_id		sThread;
};

enum {
GFX_TABLET = 'Tblt'
};


#endif