#include <stdio.h>
#include <GameKit.h>
#include "tablet.h"
#define MAXERRS 100
#include <iostream.h>
#include <fstream.h>
#include <string.h>

int main(int argc, char **argv)
{
	int32 x, y; 
	int8 bsp;
	char device;
	char muis1, muis2, wisser;
	char nabij;

	uint32 aantalbytes;
	uint8 buf[]="0123456789";


	printf("Wacom penpartner driver © 1998 by Olaf van Es <gfx@xs4all.nl> \n");


	char buff[256];
	BTSWacomTablet tablet("serial1");
	tablet.Reset();
	snooze(100000);
//	set_mouse_position(10,10);
	tablet.SetAlwaysTransmit();
	snooze(100000);
	tablet.GetModel(buff);
	printf("Model: %s\n",buff);
	tablet.SetAlwaysTransmit();

	
	while(1)	
	{

oops:
	tablet.SendCommand("@");
	aantalbytes = tablet.fPort.Read(buf,7);
//	for (int i=0 ; i<7 ; i++)
//		{
//	printf("%x ",buf[i]);
//		}
//	printf("\n");

 if (buf[0] & 0x80) // test for sync bit
 {
	
	device = buf[0] & 0x20;  // cursor or stylus ? 
	muis1 = buf[3] & 0x08;	// button 1
	muis2 = buf[3] & 0x10;	// button 2
	wisser = buf[3] & 0x20;	// eraser
	nabij = buf[0] & 0x40;	// proximity

	x = (buf[0] & 0x3 ) << 14;    // process array point[] to get one coordinate  
	x |= buf[1] << 7;
	x |= buf[2];

	y = (buf[3] & 0x3) << 14;
	y |= buf[4] << 7;
	y |= buf[5];

	bsp = (buf[3] & 0x04 ) >> 2;
	bsp |= (buf[6] & 0x7F) << 1;

	printf(" %c %c %c %c %c %5d %5d %02d\n", (device ? 'S' : 'C'),(nabij ? 'O' : '.'),(muis1 ? 'L' : '.'),(muis2 ? 'R' : '.'),(wisser ? 'W' : '.'), x, y, bsp);
	
	if (nabij) 
	  	{
	  	set_mouse_position(x/4-20,y/4-20);
	  	}
	else
		{
		snooze(100000);
		}
	}
	snooze(10000);
	}
  
}
